﻿package
{
	import flash.display.MovieClip;
	import flash.events.*;
	import flash.external.*;
	import flash.media.*;
	import flash.net.*;
	import com.bhad.browser.JSEventDispatcher;
	
	public class Player extends MovieClip
	{
		
		private var sound:Sound;
		private var channel:SoundChannel = new SoundChannel();
		private var pausePoint:Number = 0.00;
		private var currentTrack:String;
		
		public function Player():void
		{
			if(ExternalInterface.available) {
				ExternalInterface.addCallback("playFlash",playTrack);
				ExternalInterface.addCallback("pauseFlash",pauseTrack);
			}
		}

		private function loadTrack(track:String):void 
		{
			pausePoint = 0.00;
			currentTrack = track;
			sound = new Sound();
			sound.addEventListener(Event.COMPLETE, loadComplete, false, 0 , true);
			sound.load(new URLRequest(track));
		}
		
		private function loadComplete(e:Event = null):void
		{
			sound.removeEventListener(Event.COMPLETE, loadComplete, false);
			JSEventDispatcher.dispatchEvent('canplay');
			channel = sound.play();
			channel.addEventListener(Event.SOUND_COMPLETE, soundComplete, false, 0, true);
		}
		
		private function soundComplete(e:Event):void 
		{
			pausePoint = 0.00;
			JSEventDispatcher.dispatchEvent('ended');
		}
		
		private function playTrack(track:String = undefined):void 
		{	
			channel.stop();
			
			if(track == currentTrack || !track)
			{
				JSEventDispatcher.dispatchEvent('canplay');
				channel = sound.play(pausePoint);
				channel.addEventListener(Event.SOUND_COMPLETE, soundComplete, false, 0, true);
			}
			else
				loadTrack(track);
			
		}
		
		private function pauseTrack():void 
		{
			pausePoint = channel.position;
			channel.stop();
		}
	}
}